<?php

namespace BulkUpload\Handlers;

use BulkUpload\Tariff as TariffObject;
use \collection;

class Tariff {

    private array $tariffes = [];
    private collection $db;

    public function __construct()
    {
        $this->db = new collection;
        $this->setTariffes();
    }


    /**
     * Get the value of tariffes
     */ 
    public function getTariffes()
    {
        return $this->tariffes;
    }

    /**
     * Set the value of tariffes
     *
     * @return  self
     */ 
    public function setTariffes():void
    {

        $results = $this->db->search(str_replace('ovmdw_', TABLE_PREFIX, 'ovmdw_dmce_hs_codes_complete'), '', 'AND', 'DEFAULT_WHERE', '10000');

        if($results['cant_rows'] > 1){
            return;
        }

        foreach ($results as $key => $tariff) {
            if($key == 'cant_rows'){
                continue;
            }
            array_push($this->tariffes, new TariffObject($tariff));
        }

        return;

    }

    public function getTariffesForValidation():array{

        $validationTariffes = [];

        foreach ($this->tariffes as $tariff) {
            array_push($validationTariffes, $tariff->code);
        }

        return $validationTariffes;

    }
}