<?php

require($approot.'vendor/firebase/php-jwt/src/JWT.php');
require($approot.'vendor/firebase/php-jwt/src/JWK.php');
require($approot.'vendor/firebase/php-jwt/src/ExpiredException.php');
require($approot.'vendor/firebase/php-jwt/src/BeforeValidException.php');
require($approot.'vendor/firebase/php-jwt/src/SignatureInvalidException.php');

use \Firebase\JWT\JWT;

class auth
{
    private $key = 'bGS6lzFqvvSQ8ALbOxatm7/Vk7mLQyzqaS34Q4oR1ew=';
    private $time = '+30 days';
    private $server = 'bridgemarkets';
    private $token = '';
    private $userId = '';
    private $userName = '';
    private $userPass = '';
    private $response = array();
    private $status = false;

    public function __construct()
    {
    }

    public function CreateToken($user,$pass,$id='')
    {
        $issuedAt   = new DateTimeImmutable();
        $expire     = $issuedAt->modify($this->time)->getTimestamp();      // Add 60 seconds
        $serverName = $this->server;                                      // Retrieved from filtered POST data
        // aqui
        $data = [
            'iat'  => $issuedAt->getTimestamp(),         // Issued at: time when the token was generated
            'iss'  => $serverName,
            'uid'  => $id,
            'usr'  => $user,                      // Issuer
            'tks'  => base64_encode($_SERVER['HTTP_USER_AGENT']),   
            'ip'  =>  base64_encode($_SERVER['REMOTE_ADDR']),                   // Issuer
            'nbf'  => $issuedAt->getTimestamp(),         // Not before
            'exp'  => $expire,                           // Expire
        ];
        if ($jwt = JWT::encode($data, $this->key, 'HS512')) {
            $this->status = true;
            $this->token = $jwt;
            $this->response =  array(
                "message" => "Successful login.",
                "jwt" => $jwt,
                "expireAt" => $expire
            );
        } else {
            $this->status = false;
            $this->response = array(
                "message" => "error",
            );
        }
        return $this;
    }
    public function verify($jwt)
    {
        try {
            if ($token = JWT::decode($jwt, $this->key, ['HS512'])) {
                $now = new DateTimeImmutable();
                $serverName = $this->server;

                if (
                    $token->iss !== $serverName ||
                    $token->nbf > $now->getTimestamp() ||
                    $token->exp < $now->getTimestamp()
                ) {
                    $this->status = false;
                    $this->response = array(
                        "message" => "error",
                    );
                    return $this;
                }
               /*  if (
                    base64_decode($token->tks) != $_SERVER['HTTP_USER_AGENT'] || 
                    base64_decode($token->ip) != $_SERVER['REMOTE_ADDR']
                ) {
                    $this->status = false;
                    $this->response = array(
                        "message" => "error",
                    );
                    return $this;
                } */
                $this->status = true;
                // aqui
                $this->userId  = $token->uid;
                $this->userName  = $token->usr;
                $this->userPass  = base64_decode($token->tks);
                $this->response = array(
                    "message" => "ok",
                    "jwt" => $jwt,
                    "uid" => $token->uid,
                    "usr" => $token->usr,
                    "tks" => $token->tks,
                    "ip" => $token->ip,
                    "expireAt" => $token->exp,
                );
                return $this;
            } else {
                $this->status = false;
                $this->response = array(
                    "message" => "error",
                );
                return $this;
            }
        } catch (\Firebase\JWT\ExpiredException $th) {
            //echo 'Caught exception: ',  $th->getMessage(), "\n";
            $this->status = false;
            $this->response = array(
                "message" => 'error: ' . $th->getMessage(),
            );
        } catch (\Firebase\JWT\SignatureInvalidException $th) {
            //echo 'Caught exception: ',  $th->getMessage(), "\n";
            $this->status = false;
            $this->response = array(
                "message" => 'error: ' . $th->getMessage(),
            );
        } catch (\Firebase\JWT\BeforeValidException $th) {
            //echo 'Caught exception: ',  $th->getMessage(), "\n";
            $this->status = false;
            $this->response = array(
                "message" => 'error: ' . $th->getMessage(),
            );
        } catch (\UnexpectedValueException  $th) {
            //echo 'Caught exception: ',  $th->getMessage(), "\n";
            $this->status = false;
            $this->response = array(
                "message" => 'error: ' . $th->getMessage(),
            );
        }
        return $this;
    }
    public function getKey()
    {
        return $this->key;
    }
    public function getToken()
    {
        return $this->token;
    }
    public function getUser()
    {
        return $this->userId;
    }
    public function getUserName()
    {
        return $this->userName;
    }
    public function getUserPass()
    {
        return $this->userPass;
    }
    public function status()
    {
        return $this->status;
    }
    public function response()
    {
        return $this->response;
    }
    public function jsonResponse()
    {
        return json_encode($this->response);
    }
    public function found()
    {
        if (!preg_match('/Bearer\s(\S+)/', $_SERVER['HTTP_AUTHORIZATION'], $matches)) {
            return null;
        }
        return $matches[1];
    }
}