<?php

class otp extends SmsMessages
{

    private $message = 'Su código de verificación es: ( %s ) https://bridgemarkets.com';
    private $code = '';
    private $token = '';


    function send_otp_validation($phone_number, $email_text = '')
    {
        $otp = $this->generate_code_to_phone($phone_number);
        $template_msg = sprintf($this->message, $otp['code']);
        if (!$this->sendMessageTemplate($phone_number, $template_msg)) {
            throw new Exception("Error al enviar el mensaje", 410);
            return;
        }
        if ($email_text != '') {
            $email = new email();
            $email->set_destination($email_text);
            $email->set_template('Código de Verificación', $template_msg);

            if (!$email->send_mail()) {
                //throw new Exception("Error al enviar el correo", 420);
                //return;
            }
        }

        return $otp['token'];
    }

    function otp_verification($otp, $token, $code, $phone_number)
    {
        $result['status'] = hash('sha512', $code . $phone_number . $otp) == $token;
        if (!$result['status']) {
            throw new Exception("Código de Verificación invalido", 411);
            return;
        }
        $result['msg'] = 'Confirmado';
        return $result;
    }


    public function generate_code_to_phone($number)
    {
        $otp['code'] = $this->generateAuthCode();
        $this->code = $otp['code'];
        $otp['token'] = hash('sha512', $number . $this->code);
        $this->token = $otp['token'];
        return $otp;
    }

    public function generateAuthCode()
    {
        $code = '';
        for ($i = 0; $i < 6; $i++) {
            $code .= rand(0, 9);
        }
        return strval(str_pad($code, 6, "0", STR_PAD_LEFT));
    }
}
