<?php
define('DEFAULT_MESSAGE','Hemos tenido problemas procesando su pago, favor contactar a su banco emisor');
class CreditCard implements PaymentMethod
{
    private $hide_message = [
        '226' =>DEFAULT_MESSAGE,
        '250' =>DEFAULT_MESSAGE,
        '251' =>DEFAULT_MESSAGE,
        '252' =>DEFAULT_MESSAGE,
        '253' =>DEFAULT_MESSAGE,
        '261' =>DEFAULT_MESSAGE,
    '262' =>DEFAULT_MESSAGE,
    '263' =>DEFAULT_MESSAGE,
    '264' =>DEFAULT_MESSAGE,
    '410' =>DEFAULT_MESSAGE,
    '411' =>DEFAULT_MESSAGE,
    ];
    private $error_message = 
    [
    '200' =>'Transaction was declined by processor.',
    '201' =>'Do not honor.',
    '202' =>'Insufficient funds.',
    '203' =>'Over limit.',
    '204' =>'Transaction not allowed.',                               
    '220' =>'Incorrect payment information.',
    '221' =>'No such card issuer.',
    '222' =>'No card number on file with issuer.',
    '223' =>'Expired card.',
    '224' =>'Invalid expiration date.',
    '225' =>'Invalid card security code.',
    '226' =>DEFAULT_MESSAGE,
    '240' => 'Contacte a su banco',
    '250' =>DEFAULT_MESSAGE,
    '251' =>DEFAULT_MESSAGE,
    '252' =>DEFAULT_MESSAGE,
    '253' =>DEFAULT_MESSAGE,
    '260' =>'Declined with further instructions available. (See response text)',
    '261' =>DEFAULT_MESSAGE,
    '262' =>DEFAULT_MESSAGE,
    '263' =>DEFAULT_MESSAGE,
    '264' =>DEFAULT_MESSAGE,
    '300' =>'Transaction was rejected by gateway.',
    '400' =>'Transaction error returned by processor.',
    '410' =>DEFAULT_MESSAGE,
    '411' =>DEFAULT_MESSAGE,
    '420' =>'Communication error.',
    '421' =>'Communication error with issuer.',
    '430' =>'Duplicate transaction at processor.',
    '440' =>'Processor format error.',
    '441' =>'Invalid transaction information..',
    '460' =>'Processor feature not available.',
    '461' =>'Unsupported card type.',

    'N'=>'CVV2/CVC2 no match',
    'P'=>'Not processed',
    'S'=>'Merchant has indicated that CVV2/CVC2 is not present on card',
    'U'=>'Issuer is not certified and/or has not provided Visa encryption keys',
    ];

    private $api_url = NMI_URL;
    private $security_key = NMI_ACCESS_SECRET;
    private $currency = 'USD';
    private $user_id = 0;
    public $response = [];
    private $status = true;
    private $order = [];
    private $billing = [];
    private $shipping = [];
    private $cards = [];
    private $options = [];
    private $validations = ['cvv'];

    private $types_images = [];

    public $db;

    public function __construct($user)
    {
        $this->db = new collection();
        if (!isset($user) || $user == 0) {
            throw new Exception("User is Required", 1002);
        }
        $this->user_id = $user;
        $this->types_images['visa'] = 'https://bmbucket01.s3.ca-central-1.amazonaws.com/uploads/2023/03/b3b2e4b3-b2bd-4235-b329-5d729075b057.png';
        $this->types_images['master'] = 'https://bmbucket01.s3.ca-central-1.amazonaws.com/uploads/2023/03/5905c7f2-1779-443c-bafb-b3e3077c52b3.png';
        $this->types_images['amex'] = 'https://bmbucket01.s3.ca-central-1.amazonaws.com/uploads/2023/03/afb73eeb-9443-4e4f-9382-27d9555d8c37.png';
        $this->types_images['dinersclub'] = 'https://bmbucket01.s3.ca-central-1.amazonaws.com/uploads/2023/08/a3eceabc-687d-495a-8e35-46880ec5bb4e.png';
    }

    public function generateResponseSchema(array $data)
    {
    }
    public function errorResponse()
    {
    }
    public function getResponse()
    {
        return  $this->response;
    }

    public function pay(Int $option_id, Int $cvv = 0, array $totals, Destination $shipping, Destination $billing)
    {
        $this->AlertNotification();
        $card = $this->getOption($option_id, $this->user_id);
        $data=$this->prepareDataPay($card,$cvv);
        //die(print_r($card));
        $subtotal=(isset($totals['total']))?$totals['total']:0;
        $tax=(isset($totals['tax']))?$totals['tax']:0;
        $shipping_amount=(isset($totals['shipping']))?$totals['shipping']:0;
        $total = $subtotal + $tax + $shipping_amount;
        $ccexp = $data['valid_month'] . substr($data['valid_year'], -2);
        $this->setOrder('', $tax, $shipping_amount);
        $this->setBilling($billing);
        $this->setShipping($shipping);
        $this->doAuth($total, trim($data['card_number']), $ccexp, trim($data['cvv']));
        $result = $this->response;
        $this->response = [];
        if ($result['response_code'] == 100 && $result['cvvresponse'] == 'M') {
            $this->response['status'] = true;
            $this->response['message'] = $result['responsetext'];
            $this->response['errors'] = [];
            $this->response['transaction_id'] = $result['transactionid'];
            $this->response['meta'][] = array('NMI Transaction ID' => $result['transactionid']);
            $this->response['meta'][] = array('AVS Response' => $result['avsresponse']);
            $this->response['meta'][] = array('CVV Response' => $result['cvvresponse']);
            $this->response['meta'][] = array('NMI Response' => $result['responsetext']);
        } else {
            $this->response['status'] = false;
            $this->response['message'] = $result['responsetext'];
            $this->response['errors'] = [
                'msg' => $result['responsetext'],
                'value' => $result['response_code'],
            ];
            $this->response['transaction_id'] = $result['transactionid'];
            $this->response['meta'][] = array('NMI Transaction ID' => $result['transactionid']);
            $this->response['meta'][] = array('AVS Response' => $result['avsresponse']);
            $this->response['meta'][] = array('CVV Response' => $result['cvvresponse']);
            $this->response['meta'][] = array('NMI Response' => $result['responsetext']);
            $this->TransactionFailedNotification($data,$totals,$result,$billing);
        }
        $this->logTransaction($data,$totals,$result);
        return $this;
    }
    public function uniquePay(array $card, Int $cvv = 0, array $totals, Destination $shipping, Destination $billing)
    {
        /* {
            card_name : string
            card_type : string
            card_number : string
            valid_month : number
            valid_year : number
            cvv:       : number
        } */
        //$this->AlertNotification();
        $data=$card;
        //die(print_r($card));
        $subtotal=(isset($totals['total']))?$totals['total']:0;
        $tax=(isset($totals['tax']))?$totals['tax']:0;
        $shipping_amount=(isset($totals['shipping']))?$totals['shipping']:0;
        $total = $subtotal + $tax + $shipping_amount;
        $ccexp = $data['valid_month'] . substr($data['valid_year'], -2);
        $this->setOrder('', $tax, $shipping_amount);
        $this->setBilling($billing);
        $this->setShipping($shipping);
        $this->doAuth($total, trim($data['token']));
        $result = $this->response;
        if($this->CheckForErrors($result)){
            $this->TransactionFailedNotification($data,$totals,$result,$billing);
        }
        
        $this->logTransaction($data,$totals,$result);
        return $this;
    }

    public function loadOptions()
    {
        /*$option['id']='45';
        $option['title']='Tarjeta de Credito';
        $option['message']='xxxx-xxxx-xxxx-4587';
        $option['image']='https://e7.pngegg.com/pngimages/910/492/png-clipart-mastercard-logo-credit-card-visa-brand-mastercard-text-label-thumbnail.png';
        $option['validations']=$this->validations;
        $option['errors']=[];
        $this->options[]=$option; */

        $opt = $this->getAllOption($this->user_id, 'nmipay');
        for ($i = 0; $i < $opt['cant_rows']; $i++) {
            
            $this->options[] = $this->prepareDataRead($opt[$i]);
        }

        return $this->options;
    }

    private function ccMasking($number, $maskingCharacter = 'X')
    {
        return str_repeat($maskingCharacter, 4) . '-' . str_repeat($maskingCharacter, 4) . '-' . str_repeat($maskingCharacter, 4) . '-' . substr($number, -4);
    }
    public function loadProvider(Destination $destitanion)
    {
        $this->response['options'] = $this->loadOptions();
        return $this->response;
    }

    public function getOption(Int $id, Int $user)
    {

        $res = $this->db->get('bm_payment_options', $id);
        if ($res['cant_rows'] == 0 || $res[0]['user_id'] != secureToke::getHash($user)) {
            throw new Exception("Acceso no autorizado", 1005);
        }
        return $res[0];
    }

    public function getAllOption(Int $user, string $method)
    {

        $where['user_id'] = secureToke::getHash($user);
        $where['payment_method'] = $method;
        $res = $this->db->searchForce('bm_payment_options', $where);
        return $res;
    }

    public function addOption(Int $user, string $method, array $option)
    {

        /* {
            card_name : string
            card_type : string
            card_number : string
            valid_month : number
            valid_year : number
            cvv:       : number
        } */
        if (!is_numeric($option['card_number'])) {
            throw new Exception("Numero de tarjeta solo admite caracteres numéricos", 500);
            return;
        }
        /*if (!$this->isValidCard($option)) {
            throw new Exception("Tarjeta Invalida", 1516);
            return;
        }*/
        $now = strtotime(date("Y-m-d H:i:00", time()));
        $date = strtotime($option['valid_year'] . '-' . $option['valid_month'] . '-01 00:00:00');
        if ($now > $date) {
            throw new Exception("Tarjeta con fecha Expirada", 1517);
            return;
        }
        /* $decryp = secureToke::getHash(microtime());
        $validation['valid_month'] = $option['valid_month'];
        $validation['valid_year'] = $option['valid_year'];
        $data['user_id'] = secureToke::getHash($user);
        $data['payment_method'] = $method;
        $data['data'] = secureToke::tokenencrypt($option['card_number'], secureToke::getHash($option['cvv'] . $decryp));
        $data['alias'] = secureToke::tokenencrypt($this->ccMasking($option['card_number']));
        $data['type'] = secureToke::tokenencrypt($option['card_type']);
        $data['data_validation'] = secureToke::tokenencrypt(json_encode($validation));
        $data['data_code'] = secureToke::tokenencrypt($option['cvv'], secureToke::getHash($option['cvv'] . $decryp));
        $data['data_name'] = secureToke::tokenencrypt(json_encode($option['card_name']));
        $data['data_des'] = secureToke::tokenencrypt($decryp); */
        $this->db->insert('bm_payment_options', $this->prepareDataSave($user,$method,$option));
    }


    private function prepareDataRead($opt){
        $option['id'] = $opt['id'];
        
        $option['title'] = secureToke::tokendecrypt($opt['data_name']);
        $option['message'] = secureToke::tokendecrypt($opt['alias']);
        $option['image'] = $this->types_images[secureToke::tokendecrypt($opt['type'])];
        $option['validations'] = $this->validations;
        $option['errors'] = [];
        $date=json_decode(secureToke::tokendecrypt($opt['data_validation']),true);
        $now = strtotime(date("Y-m-d H:i:00", time()));
        $date = strtotime($date['valid_year'] . '-' . $date['valid_month'] . '-01 00:00:00');
        if ($now > $date) {
            $error['msg'] = 'Tarjeta con fecha Expirada';
            $error['value'] = $date['valid_year'] . '-' . $date['valid_month'];
            $option['errors'][] = $error;
        }
        return $option;
    }

    private function prepareDataPay($opt,$key){
        
        $token = secureToke::getHash($key . secureToke::tokendecrypt($opt['data_des']));
        if($key!=secureToke::tokendecrypt($opt['data_code'],$token)){
            throw new Exception("Error de validacion", 1005);
            
        }
        $date=json_decode(secureToke::tokendecrypt($opt['data_validation']),true);
        $option['id'] = $opt['id'];
        $option['title'] = secureToke::tokendecrypt($opt['data_name']);
        $option['message'] = secureToke::tokendecrypt($opt['alias']);
        $option['card_name'] = secureToke::tokendecrypt($opt['data_name']);
        $option['card_number'] = secureToke::tokendecrypt($opt['data'],$token);
        $option['cvv'] = secureToke::tokendecrypt($opt['data_code'],$token);
        $option['valid_month'] = $date['valid_month'];
        $option['valid_year'] = $date['valid_year'];
        $option['image'] = $this->types_images[secureToke::tokendecrypt($opt['type'])];
        return $option;
    }

    private function prepareDataSave(Int $user, string $method, array $option):Array{
        $data=[];
        $decryp = secureToke::getHash(microtime());
        $validation['valid_month'] = $option['valid_month'];
        $validation['valid_year'] = $option['valid_year'];
        $data['user_id'] = secureToke::getHash($user);
        $data['payment_method'] = $method;
        $data['data'] = secureToke::tokenencrypt($option['card_number'], secureToke::getHash($option['cvv'] . $decryp));
        $data['alias'] = secureToke::tokenencrypt($this->ccMasking($option['card_number']));
        $data['type'] = secureToke::tokenencrypt($option['card_type']);
        $data['data_validation'] = secureToke::tokenencrypt(json_encode($validation));
        $data['data_code'] = secureToke::tokenencrypt($option['cvv'], secureToke::getHash($option['cvv'] . $decryp));
        $data['data_name'] = secureToke::tokenencrypt($option['card_name']);
        $data['data_des'] = secureToke::tokenencrypt($decryp);
        return $data;
    }

    private function isValidCard(array $option): bool
    {
        $ccexp = $option['valid_month'] . substr($option['valid_year'], -2);
        $response = $this->doValidate($option['card_number'], $ccexp, $option['cvv']);
        $result = $this->response;
        $this->response = [];
        if ($result['response_code'] == 100) {
            return true;
        }
        return false;
    }
    public function updateOption(Int $id, Int $user, string $method, array $option)
    {
        if (!is_numeric($option['card_number'])) {
            throw new Exception("Numero de tarjeta solo admite caracteres numéricos", 500);
            return;
        }
        /*if (!$this->isValidCard($option)) {
            throw new Exception("Tarjeta Invalida", 1516);
            return;
        }*/
        $now = strtotime(date("Y-m-d H:i:00", time()));
        $date = strtotime($option['valid_year'] . '-' . $option['valid_month'] . '-01 00:00:00');
        if ($now > $date) {
            throw new Exception("Tarjeta con fecha Expirada", 1517);
            return;
        }
        $where['user_id'] = secureToke::getHash($user);
        $where['id'] = $id;

        $option['user_id'] = secureToke::getHash($user);
        $option['payment_method'] = $method;
        $this->db->update('bm_payment_options', $where, $this->prepareDataSave($user,$method,$option));
    }
    public function deleteOption(Int $id, Int $user)
    {
        $data['user_id'] = secureToke::getHash($user);
        $data['id'] = $id;
        $this->db->delete('bm_payment_options', $data);
    }


    /**
     * set order details
     */
    function setOrder($orderdescription = '', $tax = 0, $shipping = 0)
    {
        $orderid = $this->getNextOrderId();
        $this->order['orderid']          = $orderid;
        $this->order['orderdescription'] = $orderdescription;
        $this->order['tax']              = $tax;
        $this->order['shipping']         = $shipping;
        $this->order['ponumber']         = 'PO' . $orderid;
        $this->order['ipaddress']        = ($_SERVER['REMOTE_ADDR'] == '::1') ? '127.0.0.1' : $_SERVER['REMOTE_ADDR'];
        $this->order['currency']         = $this->currency;
    }

    private function getNextOrderId()
    {
        $dt = $this->db->plainQuery('SELECT MAX(ID) FROM OvMdW_posts', '', true);
        return $dt[0]['ID'] + 1;
    }

    /**
     * set billing address
     */

    function setBilling(Destination $address)
    {
        $this->billing['firstname'] = $address->first_name;
        $this->billing['lastname']  = $address->last_name;
        $this->billing['company']   = $address->company;
        $this->billing['address1']  = $address->address_1;
        $this->billing['address2']  = $address->address_2;
        $this->billing['city']      = $address->city;
        $this->billing['state']     = $address->state;
        $this->billing['zip']       = $address->postcode;
        $this->billing['country']   = $address->get_countryCode();
        $this->billing['phone']     = $address->phone;
        $this->billing['fax']       = '';
        $this->billing['email']     = $address->email;
        $this->billing['website']   = '';
    }


    /**
     * set shipping address
     */
    function setShipping(Destination $address)
    {
        $this->shipping['firstname'] = $address->first_name;
        $this->shipping['lastname']  = $address->last_name;
        $this->shipping['company']   = $address->company;
        $this->shipping['address1']  = $address->address_1;
        $this->shipping['address2']  = $address->address_2;
        $this->shipping['city']      = $address->city;
        $this->shipping['state']     = $address->state;
        $this->shipping['zip']       = $address->postcode;
        $this->shipping['country']   = $address->get_countryCode();
        $this->shipping['email']     = $address->email;
    }
    // Transaction Functions
    function doSale($amount, $ccnumber, $ccexp, $cvv = "")
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Sales Information
        $query .= "ccnumber=" . urlencode($ccnumber) . "&";
        $query .= "ccexp=" . urlencode($ccexp) . "&";
        $query .= "amount=" . urlencode(number_format($amount, 2, ".", "")) . "&";
        $query .= "cvv=" . urlencode($cvv) . "&";
        // Order Information
        $query .= "ipaddress=" . urlencode($this->order['ipaddress']) . "&";
        $query .= "orderid=" . urlencode($this->order['orderid']) . "&";
        $query .= "orderdescription=" . urlencode($this->order['orderdescription']) . "&";
        $query .= "tax=" . urlencode(number_format($this->order['tax'], 2, ".", "")) . "&";
        $query .= "shipping=" . urlencode(number_format($this->order['shipping'], 2, ".", "")) . "&";
        $query .= "ponumber=" . urlencode($this->order['ponumber']) . "&";
        // Billing Information
        $query .= "firstname=" . urlencode($this->billing['firstname']) . "&";
        $query .= "lastname=" . urlencode($this->billing['lastname']) . "&";
        $query .= "company=" . urlencode($this->billing['company']) . "&";
        $query .= "address1=" . urlencode($this->billing['address1']) . "&";
        $query .= "address2=" . urlencode($this->billing['address2']) . "&";
        $query .= "city=" . urlencode($this->billing['city']) . "&";
        $query .= "state=" . urlencode($this->billing['state']) . "&";
        $query .= "zip=" . urlencode($this->billing['zip']) . "&";
        $query .= "country=" . urlencode($this->billing['country']) . "&";
        $query .= "phone=" . urlencode($this->billing['phone']) . "&";
        $query .= "fax=" . urlencode($this->billing['fax']) . "&";
        $query .= "email=" . urlencode($this->billing['email']) . "&";
        $query .= "website=" . urlencode($this->billing['website']) . "&";
        // Shipping Information
        $query .= "shipping_firstname=" . urlencode($this->shipping['firstname']) . "&";
        $query .= "shipping_lastname=" . urlencode($this->shipping['lastname']) . "&";
        $query .= "shipping_company=" . urlencode($this->shipping['company']) . "&";
        $query .= "shipping_address1=" . urlencode($this->shipping['address1']) . "&";
        $query .= "shipping_address2=" . urlencode($this->shipping['address2']) . "&";
        $query .= "shipping_city=" . urlencode($this->shipping['city']) . "&";
        $query .= "shipping_state=" . urlencode($this->shipping['state']) . "&";
        $query .= "shipping_zip=" . urlencode($this->shipping['zip']) . "&";
        $query .= "shipping_country=" . urlencode($this->shipping['country']) . "&";
        $query .= "shipping_email=" . urlencode($this->shipping['email']) . "&";
        $query .= "type=sale";
        return $this->_doPost($query);
    }

    /**
     * generate autorization
     */
    function doAuth($amount,$paymentToken)
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Sales Information
        //$query .= "ccnumber=" . urlencode($ccnumber) . "&";
        $query .= "payment_token=" . urlencode($paymentToken) . "&";
        //$query .= "ccexp=" . urlencode($ccexp) . "&";
        $query .= "amount=" . urlencode(number_format($amount, 2, ".", "")) . "&";
       //$query .= "cvv=" . urlencode($cvv) . "&";
        // Order Information
        $query .= "ipaddress=" . urlencode($this->order['ipaddress']) . "&";
        $query .= "orderid=" . urlencode($this->order['orderid']) . "&";
        $query .= "orderdescription=" . urlencode($this->order['orderdescription']) . "&";
        $query .= "tax=" . urlencode(number_format($this->order['tax'], 2, ".", "")) . "&";
        $query .= "shipping=" . urlencode(number_format($this->order['shipping'], 2, ".", "")) . "&";
        $query .= "ponumber=" . urlencode($this->order['ponumber']) . "&";
        // Billing Information
        $query .= "firstname=" . urlencode($this->billing['firstname']) . "&";
        $query .= "lastname=" . urlencode($this->billing['lastname']) . "&";
        $query .= "company=" . urlencode($this->billing['company']) . "&";
        $query .= "address1=" . urlencode($this->billing['address1']) . "&";
        $query .= "address2=" . urlencode($this->billing['address2']) . "&";
        $query .= "city=" . urlencode($this->billing['city']) . "&";
        $query .= "state=" . urlencode($this->billing['state']) . "&";
        $query .= "zip=" . urlencode($this->billing['zip']) . "&";
        $query .= "country=" . urlencode($this->billing['country']) . "&";
        $query .= "phone=" . urlencode($this->billing['phone']) . "&";
        $query .= "fax=" . urlencode($this->billing['fax']) . "&";
        $query .= "email=" . urlencode($this->billing['email']) . "&";
        $query .= "website=" . urlencode($this->billing['website']) . "&";
        // Shipping Information
        $query .= "shipping_firstname=" . urlencode($this->shipping['firstname']) . "&";
        $query .= "shipping_lastname=" . urlencode($this->shipping['lastname']) . "&";
        $query .= "shipping_company=" . urlencode($this->shipping['company']) . "&";
        $query .= "shipping_address1=" . urlencode($this->shipping['address1']) . "&";
        $query .= "shipping_address2=" . urlencode($this->shipping['address2']) . "&";
        $query .= "shipping_city=" . urlencode($this->shipping['city']) . "&";
        $query .= "shipping_state=" . urlencode($this->shipping['state']) . "&";
        $query .= "shipping_zip=" . urlencode($this->shipping['zip']) . "&";
        $query .= "shipping_country=" . urlencode($this->shipping['country']) . "&";
        $query .= "shipping_email=" . urlencode($this->shipping['email']) . "&";
        $query .= "type=auth";
        return $this->_doPost($query);
    }

    function doValidate($ccnumber, $ccexp, $cvv = "")
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Sales Information
        $query .= "ccnumber=" . urlencode($ccnumber) . "&";
        $query .= "ccexp=" . urlencode($ccexp) . "&";
        $query .= "cvv=" . urlencode($cvv) . "&";
        $query .= "type=validate";
        return $this->_doPost($query);
    }
    /**
     * generate credit
     */
    function doCredit($amount, $ccnumber, $ccexp)
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Sales Information
        $query .= "ccnumber=" . urlencode($ccnumber) . "&";
        $query .= "ccexp=" . urlencode($ccexp) . "&";
        $query .= "amount=" . urlencode(number_format($amount, 2, ".", "")) . "&";
        // Order Information
        $query .= "ipaddress=" . urlencode($this->order['ipaddress']) . "&";
        $query .= "orderid=" . urlencode($this->order['orderid']) . "&";
        $query .= "orderdescription=" . urlencode($this->order['orderdescription']) . "&";
        $query .= "tax=" . urlencode(number_format($this->order['tax'], 2, ".", "")) . "&";
        $query .= "shipping=" . urlencode(number_format($this->order['shipping'], 2, ".", "")) . "&";
        $query .= "ponumber=" . urlencode($this->order['ponumber']) . "&";
        // Billing Information
        $query .= "firstname=" . urlencode($this->billing['firstname']) . "&";
        $query .= "lastname=" . urlencode($this->billing['lastname']) . "&";
        $query .= "company=" . urlencode($this->billing['company']) . "&";
        $query .= "address1=" . urlencode($this->billing['address1']) . "&";
        $query .= "address2=" . urlencode($this->billing['address2']) . "&";
        $query .= "city=" . urlencode($this->billing['city']) . "&";
        $query .= "state=" . urlencode($this->billing['state']) . "&";
        $query .= "zip=" . urlencode($this->billing['zip']) . "&";
        $query .= "country=" . urlencode($this->billing['country']) . "&";
        $query .= "phone=" . urlencode($this->billing['phone']) . "&";
        $query .= "fax=" . urlencode($this->billing['fax']) . "&";
        $query .= "email=" . urlencode($this->billing['email']) . "&";
        $query .= "website=" . urlencode($this->billing['website']) . "&";
        $query .= "type=credit";
        return $this->_doPost($query);
    }


    /**
     * generate refund
     */
    function doRefund($transactionid, $amount = 0)
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Transaction Information
        $query .= "transactionid=" . urlencode($transactionid) . "&";
        if ($amount > 0) {
            $query .= "amount=" . urlencode(number_format($amount, 2, ".", "")) . "&";
        }
        $query .= "type=refund";
        $this->_doPost($query);
        return $this;
    }
    /**
     * generate full refund and cancel transaction
     */
    function doCancel($transactionid)
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Transaction Information
        $query .= "transactionid=" . urlencode($transactionid) . "&";
        $query .= "type=void";
        $this->_doPost($query);
        return $this;
    }
    /**
     * generate capture previous auth transaction
     */
    function doCapture($transactionid, $amount = 0)
    {
        $query  = "";
        // Login Information
        $query .= "security_key=" . urlencode($this->security_key) . "&";
        // Transaction Information
        $query .= "transactionid=" . urlencode($transactionid) . "&";
        if ($amount > 0) {
            $query .= "amount=" . urlencode(number_format($amount, 2, ".", "")) . "&";
        }
        $query .= "type=capture";
        $this->_doPost($query);
        return $this;
    }
    /**
     * generate execute command
     */
    function _doPost($query)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->api_url);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

        curl_setopt($ch, CURLOPT_POSTFIELDS, $query);
        curl_setopt($ch, CURLOPT_POST, 1);
        //die($query);

        if (!($data = curl_exec($ch))) {
            $this->status = false;
            throw new Exception("Error Processing Request", 1001);
        }
        curl_close($ch);
        unset($ch);
        //print "\n$data\n";
        $data = explode("&", $data);
        for ($i = 0; $i < count($data); $i++) {
            $rdata = explode("=", $data[$i]);
            $this->response[$rdata[0]] = $rdata[1];
        }
        return $this;
    }
    /**
     * generate egt status
     */
    public function getStatus()
    {
        return  $this->status;
    }

    function TransactionFailedNotification(array $dataRequest, array $totals, array $result, Destination $billing) {
        $email = new email();
        $user = new User($this->user_id);
        $subtotal=(isset($totals['total']))?$totals['total']:0;
        $tax=(isset($totals['tax']))?$totals['tax']:0;
        $shipping_amount=(isset($totals['shipping']))?$totals['shipping']:0;
        $total = $subtotal + $tax + $shipping_amount;
        $email->set_multidestination(NMI_EMAIL_NOTIFICATIONS);
        $message=sprintf('Transacción Fallida con fecha %s <br>
        por parte del usuario: %s, <br>
        datos de Usuario:<br>Nombre: %s %s<br>
        Correo: %s<br>
        Teléfono: %s<br>
        País: %s<br>
        -------------------------------------------------------<br>
        Tarjeta a nombre de: %s<br>
        Número de Tarjeta: %s<br>
        Monto: %s<br>
        Motivo de rechazo: %s<br>',
        date('Y-m-d H:i:s'),
        $user->username,
        $user->first_name,
        $user->last_name,
        $user->email,
        $user->select_meta('profile_phone_code',$user->meta_data).'-'.$user->select_meta('profile_phone',$user->meta_data),
        $billing->country,
        $dataRequest['card_name'],
        $this->ccMasking($dataRequest['card_number']),
        number_format($total,2),
        $result['responsetext']
        );
        $email->set_template('Alerta de Transacción Fallida',$message);
        $email->send_mail();
    }
    private function logTransaction(Array $dataRequest,Array $totals, Array $dataResponse)
    {
        /* {
            card_name : string
            card_type : string
            card_number : string
            valid_month : number
            valid_year : number
            cvv:       : number
        } */
        $data=[];
        $data['id_user']=$this->user_id;
        $data['date']=date('Y-m-d H:i:s');
        $data['order_data']=serialize(array('order'=>$this->order,'billing'=>$this->billing));
        $data['transaction_response']=serialize($dataResponse);
        $data['transaction_status']=($dataResponse['response_code'] == 100)?'Approved':'Failed';
        $data['transaction_holder']=$dataRequest['card_name'];
        $data['transaction_type']=$dataRequest['card_type'];
        $subtotal=(isset($totals['total']))?$totals['total']:0;
        $tax=(isset($totals['tax']))?$totals['tax']:0;
        $shipping_amount=(isset($totals['shipping']))?$totals['shipping']:0;
        $total = $subtotal + $tax + $shipping_amount;
        $data['transaction_amount']=$total;
        $data['card_number']=$this->ccMasking($dataRequest['card_number']);
        //die(print_r($data));
        $this->db->insert('transaction_log_payments',$data);
    }
    private function AlertNotification()
    {
        $query=sprintf("SELECT
        Count(transaction_log_payments.id) AS request
        FROM
        transaction_log_payments
        WHERE
        transaction_log_payments.id_user = '%s' AND
        transaction_log_payments.date >= DATE_SUB('".date('Y-m-d H:i:s')."',INTERVAL %d SECOND)
        LIMIT 3", $this->user_id,3600);
        //die($query);
        $data = $this->db->plainQuery($query,false,true);
        if($data[0]['request']>3){
            $email = new email();
            $user = new User($this->user_id);
            $email->set_multidestination(ADMIN_EMAIL_NOTIFICATIONS);
            $message=sprintf("se ha detectado un comportamiento de compra anómalo  por parte del usuario: %s, procediendo a bloquear sus transacciones por el lapso de 1 hora.<br>datos de Usuario:<br>Nombre: %s %s<br>Correo: %s<br>Telefono: %s<br>Pais: %s<br>",$user->username,$user->first_name,$user->last_name,$user->email,$user->select_meta('profile_phone_code',$user->meta_data).'-'.$user->select_meta('profile_phone',$user->meta_data),$user->select_meta('profile_country',$user->meta_data));
            $email->set_template('Alerta de Transacción Sospechosa',$message);
            if($email->send_mail()){
                throw new Exception("Ha excedido es limite de transacciones por favor intente más tarde", 5001);                
            }
        }
    }

    public function CheckForErrors($result){
        $this->response = [];
        if (($result['response_code'] != 100)|| $result['cvvresponse'] != 'M') {
        
            $message = in_array($result['response_code'], $this->hide_message) ? DEFAULT_MESSAGE: $result['responsetext'];
            $this->response['status'] = false;
            $this->response['message'] = $result['responsetext'];
            $this->response['response'] = $result['response'];
            $this->response['errors'] = [
                'msg' => $result['response_code'] == 100 ? $this->error_message[$result['cvvresponse']] : $message,
                'value' => $result['response_code'],
            ];
            $this->response['transaction_id'] = $result['transactionid'];
            $this->response['meta'][] = array('NMI Transaction ID' => $result['transactionid']);
            $this->response['meta'][] = array('AVS Response' => $result['avsresponse']);
            $this->response['meta'][] = array('CVV Response' => $result['cvvresponse']);
            $this->response['meta'][] = array('NMI Response' => $result['responsetext']);
            
            return true;
            
        } 
        $this->response['status'] = true;
            $this->response['response'] = $result['response'];
            $this->response['message'] = $result['responsetext'];
            $this->response['errors'] = [];
            $this->response['transaction_id'] = $result['transactionid'];
            $this->response['meta'][] = array('NMI Transaction ID' => $result['transactionid']);
            $this->response['meta'][] = array('AVS Response' => $result['avsresponse']);
            $this->response['meta'][] = array('CVV Response' => $result['cvvresponse']);
            $this->response['meta'][] = array('NMI Response' => $result['responsetext']);
            
            return false;
    }
}
