<?php

class PackageItem
{

    private $item;
    private $product_id = 0;
    private $product_name = 0;
    private $price = 0;
    private $quantity = 0;
    private $moq = 1;
    private $weight = 0;
    private $length = 0;
    private $width = 0;
    private $height = 0;
    private $product_arancel = 0;
    private $origin = '';
    private $declared = true;
    private $fragile = false;
    private $dg = false;
    private $oversize = false;
    public $max_size = 160;
    public function __construct(array $item)
    {
        $this->item=$item;
        $this->getSelectedValue();
        
    }

    private function getSelectedValue(){
        if($this->item['variation_id']==0){
            $this->product_id=$this->item['product_id'];
            $this->price=$this->getPrice();
            $this->quantity=intval($this->item['quantity']);
            $this->product_name=$this->item['info']['name'];
            $this->weight=floatval($this->item['info']['package_weight']);
            $this->length=floatval($this->item['info']['package_length']);
            $this->width=floatval($this->item['info']['package_width']);
            $this->height=floatval($this->item['info']['package_height']);
            $this->product_arancel=$this->item['info']['product_arancel'];
            $this->origin=$this->item['info']['product_origin_country'];
            $this->declared=$this->is_declarated();
            $this->fragile=$this->is_fragile();
            $this->dg=$this->is_dg();
            $this->oversize=$this->is_Oversized();
            //die(var_dump($this->width));
        }else{
            $this->product_id=$this->item['product_id'];
            $this->product_name=$this->item['info']['name'];
            $skip=false;
            $index=0;
            foreach($this->item['info']['variations'] as $key=>$val){
                if(!$skip){
                    if($val['product_id']==$this->item['variation_id']){
                        $index=$key;
                        $skip=true;
                    }
                }
            }            
            $this->price=$this->getPrice();
            $this->quantity=intval($this->item['quantity']);
            $this->weight=floatval($this->item['info']['variations'][$index]['package_weight']);
            $this->length=floatval($this->item['info']['variations'][$index]['package_length']);
            $this->width=floatval($this->item['info']['variations'][$index]['package_width']);
            $this->height=floatval($this->item['info']['variations'][$index]['package_height']);
            $this->product_arancel=$this->item['info']['product_arancel'];
            $this->origin=$this->item['info']['product_origin_country'];
            $this->declared=$this->is_declarated();
            $this->fragile=$this->is_fragile();
            $this->dg=$this->is_dg();
            $this->oversize=$this->is_Oversized();
        }
    }

    private function getPrice() {
        if($this->item['variation_id']!=0){
            $skip=false;
            $index=0;
            foreach($this->item['info']['variations'] as $key=>$val){
                if(!$skip){
                    if($val['product_id']==$this->item['variation_id']){
                        $index=$key;
                        $skip=true;
                    }
                }
            }
            if(isset($this->item['info']['variations'][$index]['tier_options']) && count($this->item['info']['variations'][$index]['tier_options'])>0){
                $price=$this->item['info']['variations'][$index]['price'];
                $moq=$this->item['info']['variations'][$index]['moq'];
                $this->moq=$moq;
                foreach ($this->item['info']['variations'][$index]['tier_options'] as $key => $value) {
                    if((intval($this->item['quantity'])*$moq)>=$value['tier_qty']){
                        $price=$value['tier_price'];
                    }
                }
                return floatval($price*$moq);
            }
/*             if(isset($this->item['info']['tier_options']) && count($this->item['info']['tier_options'])>0){
                $price=$this->item['info']['price'];
                $moq=$this->item['info']['moq'];
                $this->moq=$moq;
                foreach ($this->item['info']['tier_options'] as $key => $value) {
                    if((intval($this->item['quantity'])*$moq)>=$value['tier_qty']){
                        $price=$value['tier_price'];
                    }
                }
                return floatval($price*$moq);
            } */
            return floatval($this->item['info']['variations'][$index]['price']*$this->item['info']['variations'][$index]['moq']);
        }else{
            if(isset($this->item['info']['tier_options']) && count($this->item['info']['tier_options'])>0){
                $price=$this->item['info']['price'];
                $moq=$this->item['info']['moq'];
                foreach ($this->item['info']['tier_options'] as $key => $value) {
                    if((intval($this->item['quantity'])*$moq)>=$value['tier_qty']){
                        $price=$value['tier_price'];
                    }
                }
                return floatval($price*$moq);
            }
        }
        return floatval($this->item['info']['price']*$this->item['info']['moq']);
    }

    public function toMap():array{
        
        $res['product_id']=$this->product_id;
        $res['product_name']=$this->product_name;
        $res['price']=$this->price;
        $res['quantity']=$this->quantity;
        $res['moq']=$this->moq;
        $res['weight']=$this->weight;
        $res['length']=$this->length;
        $res['width']=$this->width;
        $res['height']=$this->height;
        $res['product_arancel']=$this->product_arancel;
        $res['origin']=$this->origin;
        $res['declared']=$this->declared;
        $res['fragile']=$this->fragile;
        $res['dg']=$this->dg;
        $res['oversize']=$this->oversize;
        return $res;
    }

    public function getTotalWeight()
    {
        return round($this->weight*$this->quantity,2);
    }
    public function getTotalAmount()
    {
        return round($this->price*$this->quantity,2);
    }

    public function getCBM()
    {
        
        $result['air'] = ($this->quantity*($this->height*$this->width*$this->length))/5000;
        $result['ground'] = ($this->quantity*($this->height*$this->width*$this->length))/1000000;
        $result['sea'] = ($this->quantity*($this->height*$this->width*$this->length))/1000000;
        return $result;
    }

    public function getCFT(): float
    {
        return (($this->quantity*($this->height*$this->width*$this->length))/1000000)*35.315;
    }

    private function is_Oversized()
    {
        if($this->height>$this->max_size){
            return true;
        }
        if($this->width>$this->max_size){
            return true;
        }
        if($this->length>$this->max_size){
            return true;
        }
        return false;
    }
    private function is_dg()
    {
        if(false){
            return true;
        }
        return false;
    }
    private function is_fragile()
    {
        if(false){
            return true;
        }
        return false;
    }

    private function is_declarated()
    {
        if(true){
            return true;
        }
        return false;
    }

    public function get_product_id()
    {
        return $this->product_id;
    }
    public function get_product_name()
    {
        return $this->product_name;
    }
    public function get_price()
    {
        return $this->price;
    }
    public function get_quantity()
    {
        return $this->quantity;
    }
    public function get_moq()
    {
        return $this->moq;
    }
    public function get_weight()
    {
        return $this->weight;
    }
    public function get_length()
    {
        return $this->length;
    }
    public function get_width()
    {
        return $this->width;
    }
    public function get_height()
    {
        return $this->height;
    }
    public function get_product_arancel()
    {
        return $this->product_arancel;
    }
    public function get_product_origin_country()
    {
        return $this->origin;
    }
    public function get_declared()
    {
        return $this->declared;
    }
    public function get_fragile()
    {
        return $this->fragile;
    }
    public function get_dg()
    {
        return $this->dg;
    }
    public function get_oversize()
    {
        return $this->oversize;
    }
}
