<?php

use Twilio\Http\CurlClient;

class User
{
  public $id = 0;
  public $email = '';
  public $first_name = '';
  public $last_name = '';
  public $status = 0;
  public $username = '';
  public $address = [];
  public $avatar_url = '';
  public $meta_data = [];
  private $db;


  public function __construct($id = 0, $raw_data = null)
  {
    $this->db = new collection();
    if (is_array($raw_data)) {
    }
    if ($id != 0 && $id != '') {
      $row = $this->db->search(TABLE_PREFIX . 'users', array('ID' => $id));
      if ($row['cant_rows'] <= 0) {
        throw new Exception("Id User not found", 1);
      }
      $this->id = $row[0]['ID'];
      $this->email = $row[0]['user_email'];
      $this->status = $row[0]['user_status'];
      $this->username = $row[0]['user_login'];

      $meta = $this->db->search(TABLE_PREFIX . 'usermeta', array('user_id' => $id), 'AND', 'DEFAULT_WHERE', 1000);
      if ($meta['cant_rows'] <= 0) {
        throw new Exception("Id User Meta not found", 2);
      }
      $meta_parsed = $this->meta_parse($meta);
      $this->first_name = $this->select_meta('first_name', $meta_parsed);
      $this->last_name = $this->select_meta('last_name', $meta_parsed);
      $this->getAddreses();
      $this->meta_data = json_decode(json_encode($meta_parsed), true);
    }
  }

  public function setDefaultBillingAddress()
  {
    $this->db->update('bm_address', array('user_id' => $this->id), array("billing_status" => 0));
  }
  public function setDefaultShippingAddress()
  {
    $this->db->update('bm_address', array('user_id' => $this->id), array("delivery_status" => 0));
  }

  public function setAddress($data)
  {
    $data['user_id'] = $this->id;
    $data['delivery_status'] = ($data['delivery_status']) ? 1 : 0;
    $data['billing_status'] = ($data['billing_status']) ? 1 : 0;
    $data['billing_company_status'] = ($data['billing_company_status']) ? 1 : 0;
    $data['city'] = trim($data['city']);
    $data['state'] = trim($data['state']);
    if ($data['delivery_status'] == 1) {
      $this->setDefaultShippingAddress();
    }
    if ($data['billing_status'] == 1) {
      $this->setDefaultBillingAddress();
    }
    $id = $this->db->insert('bm_address', $data);

    $this->getAddreses();
    return $id;
  }

  public function updateAddress($id, $data)
  {
    $data['user_id'] = $this->id;
    $data['delivery_status'] = ($data['delivery_status']) ? 1 : 0;
    $data['billing_status'] = ($data['billing_status']) ? 1 : 0;
    $data['billing_company_status'] = ($data['billing_company_status']) ? 1 : 0;
    $data['city'] = trim($data['city']);
    $data['state'] = trim($data['state']);
    //die(var_dump($data['city']));
    if ($data['delivery_status'] == 1) {
      $this->setDefaultShippingAddress();
    }
    if ($data['billing_status'] == 1) {
      $this->setDefaultBillingAddress();
    }
    $id = $this->db->update('bm_address', array('id' => $id), $data);

    $this->getAddreses();
    return $id;
  }

  public function deleteAddress($id)
  {

    $id = $this->db->delete('bm_address', array('id' => $id));
    $this->getAddreses();
    return $id;
  }

  public function getAddreses()
  {
    $this->address = [];
    $addresses = $this->db->search('bm_address', array('user_id' => $this->id));
    for ($i = 0; $i < $addresses['cant_rows']; $i++) {
      $dt['id'] = $addresses[$i]['id'];
      $dt['alias'] = $addresses[$i]['alias'];
      $dt['first_name'] = $addresses[$i]['first_name'];
      $dt['last_name'] = $addresses[$i]['last_name'];
      $dt['company'] = $addresses[$i]['company'];
      $dt['company_id'] = $addresses[$i]['company_id'];
      $dt['address_1'] = $addresses[$i]['address_1'];
      $dt['address_2'] = $addresses[$i]['address_2'];
      $dt['city'] = trim($addresses[$i]['city']);
      $dt['postcode'] = strval($addresses[$i]['postcode']);
      $dt['country'] = $addresses[$i]['country'];
      $dt['state'] = $addresses[$i]['state'];
      $dt['email'] = $addresses[$i]['email'];
      $dt['phone'] = $addresses[$i]['phone'];
      $dt['delivery_status'] = ($addresses[$i]['delivery_status'] == 1) ? true : false;
      $dt['billing_status'] = ($addresses[$i]['billing_status'] == 1) ? true : false;
      $dt['billing_company_status'] = ($addresses[$i]['billing_company_status'] == 1) ? true : false;
      array_push($this->address, $dt);
      unset($dt);
    }
    return $this;
  }

  public function updatePass($new_password)
  {
    return $this->db->update(TABLE_PREFIX . 'users', array('ID' => $this->id), array('user_pass' => $new_password));
  }

  public function select_meta($key, $meta_parsed)
  {
    foreach ($meta_parsed as $value) {
      if (isset($value['key']) && $value['key'] == $key) {
        return $value['value'];
        break;
      }
    }
    return '';
  }

  public function meta_parse($meta)
  {
    if (!is_array($meta)) {
      return [];
    }
    $m = new MetaValues();
    $arr = [];
    foreach ($meta as $key => $line) {
      if (isset($line['meta_key'])) {
        array_push($arr, array("key" => $line['meta_key'], "value" => $m->maybe_unserialize($line['meta_value'])));
      }
    }
    return $arr;
  }

  public function toJson()
  {
    $data['id'] = $this->id;
    $data['email'] = $this->email;
    $data['first_name'] = $this->first_name;
    $data['last_name'] = $this->last_name;
    $data['status'] = $this->status;
    $data['username'] = $this->username;
    $data['address'] = $this->address;
    $data['avatar_url'] = $this->avatar_url;
    $data['meta_data'] = $this->meta_data;
    return json_encode($data);
  }

  public function toArray()
  {
    $data['id'] = $this->id;
    $data['email'] = $this->email;
    $data['first_name'] = $this->first_name;
    $data['last_name'] = $this->last_name;
    $data['status'] = $this->status;
    $data['username'] = $this->username;
    $data['address'] = $this->address;
    $data['avatar_url'] = $this->avatar_url;
    $data['meta_data'] = $this->meta_data;
    return $data;
  }

  public function AddressValidation($destination)
  {

    $response = [];
    $destination=new Destination($destination);
    $address['type'] = 'delivery';
    $address['countryCode'] = $destination->get_countryCode();
    $address['postalCode'] = $destination->postcode;
    $address['cityName'] = trim(remove_diacritics($destination->city));
   // die(var_dump($address['cityName']));
    $address['strictValidation'] = 'true';
    $curl = new CurlRequest(DHL_ACCESS_KEY, DHL_ACCESS_SECRET);
    $url=DHL_URL . 'address-validate?' . http_build_query($address,'',null, PHP_QUERY_RFC3986);
    $data=$curl->request($url, 'GET', '');
    if (!$curl->status()) {
      $response['status'] = false;
      $response['response'] = $this->getErrorMessage($curl->toObject()['detail']);
      return $response;
    }
    $response['status'] = true;
    $response['response'] = $curl->toObject();
    return $response;
  }

  public function getErrorMessage($error)
  {
    $errorList = [
      'Parameters not having correct format: countryCode (minLength=2, maxLength=2)' => 'Parámetros no tienen el formato correcto: Código País (min=2, max=2 caracteres)',
      'Parameters not having correct format: postalCode' => 'Parámetros no tienen el formato correcto: Código Postal',
      'Parameters not having correct format: cityName (maxLength=45)' => 'Parámetros sin el formato correcto: Nombre ciudad (Máximo 45 caracteres)',
      '3001: The identified service area for the given address is currently suspended.' => '3001: El área de servicio identificada para la dirección indicada está actualmente suspendida.',
      '3002: The identified service area for the given address is currently unavailable.' => '3002: El área de servicio identificada para la dirección indicada no está disponible actualmente.',
      '3003: The identified service area for the given address is not yet open.' => '3003: El área de servicio identificada para la dirección proporcionada aún no está abierta.',
      '3004: The identified service area for the given address is closed.' => '3004: El área de servicio identificada para la dirección proporcionada está cerrada.',
      '3005: The identified service area for the given address has an unknown status.' => '3005: El área de servicio identificada para la dirección dada tiene un estado desconocido.',
      '3006: The destination country code could not be found. Please check the country code' => '3006: El código de país de destino no se puede encontrar. Favor verificar el código de país',
      '3007: The destination location is invalid. Please check the data.' => '3007: La localidad de destino es invalida. Favor verificar la data',
      '3008: Postcode not found. Expected formats: US - 99999-9999(5), 99999(5)' => 'Código postal no encontrado',
      '3009: Address validation failed.' => 'Error al validar la dirección',
      '3010: At least a City or PostalCode must be provided in the request.' => '3010: Se debe proporcionar al menos una Ciudad o Código Postal en la solicitud.',
      '3011: Service is unavailable for the given origin address.' => '3011: El servicio no está disponible para la dirección de origen proporcionada.',
      '8003: Account not allowed for this service. Please contact your DHL Express representative.' => '8003: Cuenta no permitida para este servicio. Comuníquese con su representante de DHL Express.',
      '8032: Not authorized to use this service. Please contact your DHL Express representative.' => '032: No autorizado para utilizar este servicio. Comuníquese con su representante de DHL Express.',
    ];
    if (in_array($error, array_keys($errorList))) {
      return $errorList[$error];
    } else {
      return 'Error al validar la dirección, por favor introduzca una dirección válida';
    }
  }
}
