<?php

use BulkUpload\Handlers\File as FileManager;

require('../../../cfg.php');
$errors=[];
if (true) {
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    switch ($requestMethod) {
        case 'GET':
            switch($_GET['action']){
                case 'simpleTemplate':
                    $manager = new FileManager;
                    return $manager->setHeaders(name: "plantilla_simple");
                default:
                    $manager = new FileManager;
                    return $manager->setHeaders(name: "plantilla");
            }

        case 'POST':
            switch($_GET['action']){
                case 'uploadFile':
                    try {
                        if(($_GET['disclaimer'] == "no")){
                            throw new Exception("No se puede proseguir con el proceso si no se ha aceptado el descargo de responsabilidad.", 1);
                            
                        }
                        $csv_separator = "";
                        $is_updatable = 0;
                        if(isset($_GET['csv_separator'])){
                            $csv_separator = $_GET['csv_separator'];
                        }
                        if(isset($_GET['is_updatable'])){
                            $is_updatable = $_GET['is_updatable'];
                        }
                        $manager = new FileManager;
                        if(isset($_FILES['files'])){
                            $response = $manager->saveBulkUploadFile($_FILES['files'], csv_separator:$csv_separator, is_updatable:$is_updatable);
                            if($response["status"]){
                                $rest = new RestResponse(true, $response);
                                $rest->toJson()->setMessage('OK.');
                            } else {
                                $rest = new RestResponse(false, null);
                                $rest->toJson()->setMessage('Error.');
                            }
    
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                        $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
                case 'mapFields':
                    try {
                        if(!isset($_POST)){
                            throw new Exception("No se han recibido ningún mapa de columnas.", 1);
                        }
                        if(!isset($_GET['process_id'])){
                            throw new Exception("No se han recibio ningún identificador de proceso.", 1);
                        }
                        $manager = new FileManager;
                        $response = $manager->updateColumnMap($_POST, $_GET['process_id']);
                        if($response["status"]){
                            $rest = new RestResponse(true, $response);
                            $rest->toJson()->setMessage('OK.');
                        } else {
                            $rest = new RestResponse(false, null);
                            $rest->toJson()->setMessage('Error.');
                        }
                    } catch (\Throwable $th) {
                        $rest = new RestResponse(false, null);
                        $rest->toJson()->setMessage($th->getMessage());
                    }
                    break;
            }
    }
}
if (!isset($rest) || !is_object($rest)) {
    $rest = new RestResponse(false, null);
    $rest->toJson()->setMessage('Acceso Restringido');
}
$rest->execute();
